/**
 * 项目：互联网医疗
 * 模型分组：服务管理
 * 模型名称：医生信息表
 * @Author: xiongwei
 * @Date: 2023-09-05 09:42:00
 */

package com.xwd.hospital.server.service;

import java.util.List;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.xwd.hospital.server.base.BaseService;
import com.xwd.hospital.server.domain.DoctorInfo;
import com.xwd.hospital.server.dto.DoctorDto;
import com.xwd.hospital.server.dto.DoctorInfoDto;
import com.xwd.hospital.server.dto.PatientInfoDto;
import com.xwd.hospital.server.dto.ReferralDoctorDto;
import com.xwd.hospital.server.rest.req.DoctorInfoParam;
import com.xwd.hospital.server.rest.req.DoctorSearchParam;

public interface DoctorInfoService extends BaseService<DoctorInfo> {

    IPage<DoctorDto> queryDoctorList(Page<DoctorDto> page,DoctorSearchParam param);

    DoctorInfoDto queryDoctorDetail(Long doctorId,Long userId);
    IPage<PatientInfoDto> queryMyPatient(Page<PatientInfoDto> page,String patientName);


    IPage<ReferralDoctorDto> queryDoctorByHospitalId(Page<ReferralDoctorDto> page, Long hospitalId,String doctorName);
}
